#ifndef _AIPLAYER_H
#define _AIPLAYER_H

#include "Player.h"
#include "Position.h"
#include "Chessboard.h"
#include <utility>

class AiPlayer: public Player
{
    public:
    vector<std::pair<Position, Position>> get_solve(Chessboard board, char turn, int depth);
    virtual pair<Position, Position> get_move(Chessboard board, char color);
};

#endif