#ifndef _CHESSENGINE_H
#define _CHESSENGINE_H

#include "Player.h"
#include "Figure.h"
#include "Chessboard.h"
#include <vector>

class Chessengine
{
    private:
    char turn;
    Player* player1;
    Player* player2;
    Player* player;
    Chessboard board;

    bool king_on_board(char color);

    public:
    Chessengine(Player* p1, Player* p2);
    void load(vector<Figure*> figures, char turn);
    void load_base();

    void start();
};

#endif