#include "Chessboard.h"
#include "Position.h"
#include "Figure.h"
#include "Pawn.h"
#include "Horse.h"
#include "Bishop.h"
#include "Rook.h"
#include "Queen.h"
#include "King.h"
#include <iostream>
#include <vector>

using namespace std;

int main() {
    vector<Figure*> figures;
    Horse bh(Position('A', '7'), 'B');
    King bk(Position('C', '8'), 'B');
    Bishop bb(Position('E', '8'), 'B');
    Queen bq(Position('B', '6'), 'B');
    Rook br(Position('C', '6'), 'B');

    Pawn wp(Position('F', '3'), 'W');
    King wk(Position('D', '2'), 'W');

    figures.push_back(&bh);
    figures.push_back(&bk);
    figures.push_back(&bb);
    figures.push_back(&bq);
    figures.push_back(&br);

    figures.push_back(&wp);
    figures.push_back(&wk);

    Chessboard board(figures);

    cout << board;

    board.create_move(Position('E', '8'), Position('G', '6'));

    cout << board;

    // vector<Figure*> figures2;
    // King jbk(Position('E', '8'), 'B');
    // Rook jbr(Position('A', '8'), 'B');
    // Rook jbr2(Position('H', '8'), 'B');

    // King jwk(Position('E', '1'), 'W');
    // Rook jwr(Position('A', '1'), 'W');
    // Rook jwr2(Position('H', '1'), 'W');

    // figures2.push_back(&jbk);
    // figures2.push_back(&jbr);
    // figures2.push_back(&jbr2);

    // figures2.push_back(&jwk);
    // figures2.push_back(&jwr);
    // figures2.push_back(&jwr2);

    // Chessboard board2(figures2);

    // cout << board2;
    return 0;
}